"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Since: cosmos-sdk 0.46"""
import builtins
import collections.abc
import cosmos.base.v1beta1.coin_pb2
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.duration_pb2
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _VoteOption:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _VoteOptionEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_VoteOption.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    VOTE_OPTION_UNSPECIFIED: _VoteOption.ValueType  # 0
    """VOTE_OPTION_UNSPECIFIED defines a no-op vote option."""
    VOTE_OPTION_YES: _VoteOption.ValueType  # 1
    """VOTE_OPTION_YES defines a yes vote option."""
    VOTE_OPTION_ABSTAIN: _VoteOption.ValueType  # 2
    """VOTE_OPTION_ABSTAIN defines an abstain vote option."""
    VOTE_OPTION_NO: _VoteOption.ValueType  # 3
    """VOTE_OPTION_NO defines a no vote option."""
    VOTE_OPTION_NO_WITH_VETO: _VoteOption.ValueType  # 4
    """VOTE_OPTION_NO_WITH_VETO defines a no with veto vote option."""

class VoteOption(_VoteOption, metaclass=_VoteOptionEnumTypeWrapper):
    """VoteOption enumerates the valid vote options for a given governance proposal."""

VOTE_OPTION_UNSPECIFIED: VoteOption.ValueType  # 0
"""VOTE_OPTION_UNSPECIFIED defines a no-op vote option."""
VOTE_OPTION_YES: VoteOption.ValueType  # 1
"""VOTE_OPTION_YES defines a yes vote option."""
VOTE_OPTION_ABSTAIN: VoteOption.ValueType  # 2
"""VOTE_OPTION_ABSTAIN defines an abstain vote option."""
VOTE_OPTION_NO: VoteOption.ValueType  # 3
"""VOTE_OPTION_NO defines a no vote option."""
VOTE_OPTION_NO_WITH_VETO: VoteOption.ValueType  # 4
"""VOTE_OPTION_NO_WITH_VETO defines a no with veto vote option."""
global___VoteOption = VoteOption

class _ProposalStatus:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ProposalStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ProposalStatus.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    PROPOSAL_STATUS_UNSPECIFIED: _ProposalStatus.ValueType  # 0
    """PROPOSAL_STATUS_UNSPECIFIED defines the default proposal status."""
    PROPOSAL_STATUS_DEPOSIT_PERIOD: _ProposalStatus.ValueType  # 1
    """PROPOSAL_STATUS_DEPOSIT_PERIOD defines a proposal status during the deposit
    period.
    """
    PROPOSAL_STATUS_VOTING_PERIOD: _ProposalStatus.ValueType  # 2
    """PROPOSAL_STATUS_VOTING_PERIOD defines a proposal status during the voting
    period.
    """
    PROPOSAL_STATUS_PASSED: _ProposalStatus.ValueType  # 3
    """PROPOSAL_STATUS_PASSED defines a proposal status of a proposal that has
    passed.
    """
    PROPOSAL_STATUS_REJECTED: _ProposalStatus.ValueType  # 4
    """PROPOSAL_STATUS_REJECTED defines a proposal status of a proposal that has
    been rejected.
    """
    PROPOSAL_STATUS_FAILED: _ProposalStatus.ValueType  # 5
    """PROPOSAL_STATUS_FAILED defines a proposal status of a proposal that has
    failed.
    """

class ProposalStatus(_ProposalStatus, metaclass=_ProposalStatusEnumTypeWrapper):
    """ProposalStatus enumerates the valid statuses of a proposal."""

PROPOSAL_STATUS_UNSPECIFIED: ProposalStatus.ValueType  # 0
"""PROPOSAL_STATUS_UNSPECIFIED defines the default proposal status."""
PROPOSAL_STATUS_DEPOSIT_PERIOD: ProposalStatus.ValueType  # 1
"""PROPOSAL_STATUS_DEPOSIT_PERIOD defines a proposal status during the deposit
period.
"""
PROPOSAL_STATUS_VOTING_PERIOD: ProposalStatus.ValueType  # 2
"""PROPOSAL_STATUS_VOTING_PERIOD defines a proposal status during the voting
period.
"""
PROPOSAL_STATUS_PASSED: ProposalStatus.ValueType  # 3
"""PROPOSAL_STATUS_PASSED defines a proposal status of a proposal that has
passed.
"""
PROPOSAL_STATUS_REJECTED: ProposalStatus.ValueType  # 4
"""PROPOSAL_STATUS_REJECTED defines a proposal status of a proposal that has
been rejected.
"""
PROPOSAL_STATUS_FAILED: ProposalStatus.ValueType  # 5
"""PROPOSAL_STATUS_FAILED defines a proposal status of a proposal that has
failed.
"""
global___ProposalStatus = ProposalStatus

@typing_extensions.final
class WeightedVoteOption(google.protobuf.message.Message):
    """WeightedVoteOption defines a unit of vote for vote split."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OPTION_FIELD_NUMBER: builtins.int
    WEIGHT_FIELD_NUMBER: builtins.int
    option: global___VoteOption.ValueType
    """option defines the valid vote options, it must not contain duplicate vote options."""
    weight: builtins.str
    """weight is the vote weight associated with the vote option."""
    def __init__(
        self,
        *,
        option: global___VoteOption.ValueType = ...,
        weight: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["option", b"option", "weight", b"weight"]) -> None: ...

global___WeightedVoteOption = WeightedVoteOption

@typing_extensions.final
class Deposit(google.protobuf.message.Message):
    """Deposit defines an amount deposited by an account address to an active
    proposal.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    DEPOSITOR_FIELD_NUMBER: builtins.int
    AMOUNT_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    depositor: builtins.str
    """depositor defines the deposit addresses from the proposals."""
    @property
    def amount(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """amount to be deposited by depositor."""
    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        depositor: builtins.str = ...,
        amount: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["amount", b"amount", "depositor", b"depositor", "proposal_id", b"proposal_id"]) -> None: ...

global___Deposit = Deposit

@typing_extensions.final
class Proposal(google.protobuf.message.Message):
    """Proposal defines the core field members of a governance proposal."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    MESSAGES_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    FINAL_TALLY_RESULT_FIELD_NUMBER: builtins.int
    SUBMIT_TIME_FIELD_NUMBER: builtins.int
    DEPOSIT_END_TIME_FIELD_NUMBER: builtins.int
    TOTAL_DEPOSIT_FIELD_NUMBER: builtins.int
    VOTING_START_TIME_FIELD_NUMBER: builtins.int
    VOTING_END_TIME_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    TITLE_FIELD_NUMBER: builtins.int
    SUMMARY_FIELD_NUMBER: builtins.int
    PROPOSER_FIELD_NUMBER: builtins.int
    id: builtins.int
    """id defines the unique id of the proposal."""
    @property
    def messages(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[google.protobuf.any_pb2.Any]:
        """messages are the arbitrary messages to be executed if the proposal passes."""
    status: global___ProposalStatus.ValueType
    """status defines the proposal status."""
    @property
    def final_tally_result(self) -> global___TallyResult:
        """final_tally_result is the final tally result of the proposal. When
        querying a proposal via gRPC, this field is not populated until the
        proposal's voting period has ended.
        """
    @property
    def submit_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """submit_time is the time of proposal submission."""
    @property
    def deposit_end_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """deposit_end_time is the end time for deposition."""
    @property
    def total_deposit(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """total_deposit is the total deposit on the proposal."""
    @property
    def voting_start_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """voting_start_time is the starting time to vote on a proposal."""
    @property
    def voting_end_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """voting_end_time is the end time of voting on a proposal."""
    metadata: builtins.str
    """metadata is any arbitrary metadata attached to the proposal."""
    title: builtins.str
    """title is the title of the proposal

    Since: cosmos-sdk 0.47
    """
    summary: builtins.str
    """summary is a short summary of the proposal

    Since: cosmos-sdk 0.47
    """
    proposer: builtins.str
    """Proposer is the address of the proposal sumbitter

    Since: cosmos-sdk 0.47
    """
    def __init__(
        self,
        *,
        id: builtins.int = ...,
        messages: collections.abc.Iterable[google.protobuf.any_pb2.Any] | None = ...,
        status: global___ProposalStatus.ValueType = ...,
        final_tally_result: global___TallyResult | None = ...,
        submit_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        deposit_end_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        total_deposit: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
        voting_start_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        voting_end_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        metadata: builtins.str = ...,
        title: builtins.str = ...,
        summary: builtins.str = ...,
        proposer: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["deposit_end_time", b"deposit_end_time", "final_tally_result", b"final_tally_result", "submit_time", b"submit_time", "voting_end_time", b"voting_end_time", "voting_start_time", b"voting_start_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["deposit_end_time", b"deposit_end_time", "final_tally_result", b"final_tally_result", "id", b"id", "messages", b"messages", "metadata", b"metadata", "proposer", b"proposer", "status", b"status", "submit_time", b"submit_time", "summary", b"summary", "title", b"title", "total_deposit", b"total_deposit", "voting_end_time", b"voting_end_time", "voting_start_time", b"voting_start_time"]) -> None: ...

global___Proposal = Proposal

@typing_extensions.final
class TallyResult(google.protobuf.message.Message):
    """TallyResult defines a standard tally for a governance proposal."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    YES_COUNT_FIELD_NUMBER: builtins.int
    ABSTAIN_COUNT_FIELD_NUMBER: builtins.int
    NO_COUNT_FIELD_NUMBER: builtins.int
    NO_WITH_VETO_COUNT_FIELD_NUMBER: builtins.int
    yes_count: builtins.str
    """yes_count is the number of yes votes on a proposal."""
    abstain_count: builtins.str
    """abstain_count is the number of abstain votes on a proposal."""
    no_count: builtins.str
    """no_count is the number of no votes on a proposal."""
    no_with_veto_count: builtins.str
    """no_with_veto_count is the number of no with veto votes on a proposal."""
    def __init__(
        self,
        *,
        yes_count: builtins.str = ...,
        abstain_count: builtins.str = ...,
        no_count: builtins.str = ...,
        no_with_veto_count: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["abstain_count", b"abstain_count", "no_count", b"no_count", "no_with_veto_count", b"no_with_veto_count", "yes_count", b"yes_count"]) -> None: ...

global___TallyResult = TallyResult

@typing_extensions.final
class Vote(google.protobuf.message.Message):
    """Vote defines a vote on a governance proposal.
    A Vote consists of a proposal ID, the voter, and the vote option.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPOSAL_ID_FIELD_NUMBER: builtins.int
    VOTER_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    proposal_id: builtins.int
    """proposal_id defines the unique id of the proposal."""
    voter: builtins.str
    """voter is the voter address of the proposal."""
    @property
    def options(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___WeightedVoteOption]:
        """options is the weighted vote options."""
    metadata: builtins.str
    """metadata is any  arbitrary metadata to attached to the vote."""
    def __init__(
        self,
        *,
        proposal_id: builtins.int = ...,
        voter: builtins.str = ...,
        options: collections.abc.Iterable[global___WeightedVoteOption] | None = ...,
        metadata: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["metadata", b"metadata", "options", b"options", "proposal_id", b"proposal_id", "voter", b"voter"]) -> None: ...

global___Vote = Vote

@typing_extensions.final
class DepositParams(google.protobuf.message.Message):
    """DepositParams defines the params for deposits on governance proposals."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MIN_DEPOSIT_FIELD_NUMBER: builtins.int
    MAX_DEPOSIT_PERIOD_FIELD_NUMBER: builtins.int
    @property
    def min_deposit(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """Minimum deposit for a proposal to enter voting period."""
    @property
    def max_deposit_period(self) -> google.protobuf.duration_pb2.Duration:
        """Maximum period for Atom holders to deposit on a proposal. Initial value: 2
        months.
        """
    def __init__(
        self,
        *,
        min_deposit: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
        max_deposit_period: google.protobuf.duration_pb2.Duration | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["max_deposit_period", b"max_deposit_period"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["max_deposit_period", b"max_deposit_period", "min_deposit", b"min_deposit"]) -> None: ...

global___DepositParams = DepositParams

@typing_extensions.final
class VotingParams(google.protobuf.message.Message):
    """VotingParams defines the params for voting on governance proposals."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOTING_PERIOD_FIELD_NUMBER: builtins.int
    @property
    def voting_period(self) -> google.protobuf.duration_pb2.Duration:
        """Duration of the voting period."""
    def __init__(
        self,
        *,
        voting_period: google.protobuf.duration_pb2.Duration | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["voting_period", b"voting_period"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["voting_period", b"voting_period"]) -> None: ...

global___VotingParams = VotingParams

@typing_extensions.final
class TallyParams(google.protobuf.message.Message):
    """TallyParams defines the params for tallying votes on governance proposals."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    QUORUM_FIELD_NUMBER: builtins.int
    THRESHOLD_FIELD_NUMBER: builtins.int
    VETO_THRESHOLD_FIELD_NUMBER: builtins.int
    quorum: builtins.str
    """Minimum percentage of total stake needed to vote for a result to be
    considered valid.
    """
    threshold: builtins.str
    """Minimum proportion of Yes votes for proposal to pass. Default value: 0.5."""
    veto_threshold: builtins.str
    """Minimum value of Veto votes to Total votes ratio for proposal to be
    vetoed. Default value: 1/3.
    """
    def __init__(
        self,
        *,
        quorum: builtins.str = ...,
        threshold: builtins.str = ...,
        veto_threshold: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["quorum", b"quorum", "threshold", b"threshold", "veto_threshold", b"veto_threshold"]) -> None: ...

global___TallyParams = TallyParams

@typing_extensions.final
class Params(google.protobuf.message.Message):
    """Params defines the parameters for the x/gov module.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MIN_DEPOSIT_FIELD_NUMBER: builtins.int
    MAX_DEPOSIT_PERIOD_FIELD_NUMBER: builtins.int
    VOTING_PERIOD_FIELD_NUMBER: builtins.int
    QUORUM_FIELD_NUMBER: builtins.int
    THRESHOLD_FIELD_NUMBER: builtins.int
    VETO_THRESHOLD_FIELD_NUMBER: builtins.int
    MIN_INITIAL_DEPOSIT_RATIO_FIELD_NUMBER: builtins.int
    BURN_VOTE_QUORUM_FIELD_NUMBER: builtins.int
    BURN_PROPOSAL_DEPOSIT_PREVOTE_FIELD_NUMBER: builtins.int
    BURN_VOTE_VETO_FIELD_NUMBER: builtins.int
    @property
    def min_deposit(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.v1beta1.coin_pb2.Coin]:
        """Minimum deposit for a proposal to enter voting period."""
    @property
    def max_deposit_period(self) -> google.protobuf.duration_pb2.Duration:
        """Maximum period for Atom holders to deposit on a proposal. Initial value: 2
        months.
        """
    @property
    def voting_period(self) -> google.protobuf.duration_pb2.Duration:
        """Duration of the voting period."""
    quorum: builtins.str
    """ Minimum percentage of total stake needed to vote for a result to be
     considered valid.
    """
    threshold: builtins.str
    """ Minimum proportion of Yes votes for proposal to pass. Default value: 0.5."""
    veto_threshold: builtins.str
    """ Minimum value of Veto votes to Total votes ratio for proposal to be
     vetoed. Default value: 1/3.
    """
    min_initial_deposit_ratio: builtins.str
    """ The ratio representing the proportion of the deposit value that must be paid at proposal submission."""
    burn_vote_quorum: builtins.bool
    """burn deposits if a proposal does not meet quorum"""
    burn_proposal_deposit_prevote: builtins.bool
    """burn deposits if the proposal does not enter voting period"""
    burn_vote_veto: builtins.bool
    """burn deposits if quorum with vote type no_veto is met"""
    def __init__(
        self,
        *,
        min_deposit: collections.abc.Iterable[cosmos.base.v1beta1.coin_pb2.Coin] | None = ...,
        max_deposit_period: google.protobuf.duration_pb2.Duration | None = ...,
        voting_period: google.protobuf.duration_pb2.Duration | None = ...,
        quorum: builtins.str = ...,
        threshold: builtins.str = ...,
        veto_threshold: builtins.str = ...,
        min_initial_deposit_ratio: builtins.str = ...,
        burn_vote_quorum: builtins.bool = ...,
        burn_proposal_deposit_prevote: builtins.bool = ...,
        burn_vote_veto: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["max_deposit_period", b"max_deposit_period", "voting_period", b"voting_period"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["burn_proposal_deposit_prevote", b"burn_proposal_deposit_prevote", "burn_vote_quorum", b"burn_vote_quorum", "burn_vote_veto", b"burn_vote_veto", "max_deposit_period", b"max_deposit_period", "min_deposit", b"min_deposit", "min_initial_deposit_ratio", b"min_initial_deposit_ratio", "quorum", b"quorum", "threshold", b"threshold", "veto_threshold", b"veto_threshold", "voting_period", b"voting_period"]) -> None: ...

global___Params = Params
