"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import cosmos.base.abci.v1beta1.abci_pb2
import cosmos.base.query.v1beta1.pagination_pb2
import cosmos.tx.v1beta1.tx_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sys
import tendermint.types.block_pb2
import tendermint.types.types_pb2
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _OrderBy:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _OrderByEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_OrderBy.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    ORDER_BY_UNSPECIFIED: _OrderBy.ValueType  # 0
    """ORDER_BY_UNSPECIFIED specifies an unknown sorting order. OrderBy defaults to ASC in this case."""
    ORDER_BY_ASC: _OrderBy.ValueType  # 1
    """ORDER_BY_ASC defines ascending order"""
    ORDER_BY_DESC: _OrderBy.ValueType  # 2
    """ORDER_BY_DESC defines descending order"""

class OrderBy(_OrderBy, metaclass=_OrderByEnumTypeWrapper):
    """OrderBy defines the sorting order"""

ORDER_BY_UNSPECIFIED: OrderBy.ValueType  # 0
"""ORDER_BY_UNSPECIFIED specifies an unknown sorting order. OrderBy defaults to ASC in this case."""
ORDER_BY_ASC: OrderBy.ValueType  # 1
"""ORDER_BY_ASC defines ascending order"""
ORDER_BY_DESC: OrderBy.ValueType  # 2
"""ORDER_BY_DESC defines descending order"""
global___OrderBy = OrderBy

class _BroadcastMode:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _BroadcastModeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_BroadcastMode.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    BROADCAST_MODE_UNSPECIFIED: _BroadcastMode.ValueType  # 0
    """zero-value for mode ordering"""
    BROADCAST_MODE_BLOCK: _BroadcastMode.ValueType  # 1
    """DEPRECATED: use BROADCAST_MODE_SYNC instead,
    BROADCAST_MODE_BLOCK is not supported by the SDK from v0.47.x onwards.
    """
    BROADCAST_MODE_SYNC: _BroadcastMode.ValueType  # 2
    """BROADCAST_MODE_SYNC defines a tx broadcasting mode where the client waits for
    a CheckTx execution response only.
    """
    BROADCAST_MODE_ASYNC: _BroadcastMode.ValueType  # 3
    """BROADCAST_MODE_ASYNC defines a tx broadcasting mode where the client returns
    immediately.
    """

class BroadcastMode(_BroadcastMode, metaclass=_BroadcastModeEnumTypeWrapper):
    """BroadcastMode specifies the broadcast mode for the TxService.Broadcast RPC method."""

BROADCAST_MODE_UNSPECIFIED: BroadcastMode.ValueType  # 0
"""zero-value for mode ordering"""
BROADCAST_MODE_BLOCK: BroadcastMode.ValueType  # 1
"""DEPRECATED: use BROADCAST_MODE_SYNC instead,
BROADCAST_MODE_BLOCK is not supported by the SDK from v0.47.x onwards.
"""
BROADCAST_MODE_SYNC: BroadcastMode.ValueType  # 2
"""BROADCAST_MODE_SYNC defines a tx broadcasting mode where the client waits for
a CheckTx execution response only.
"""
BROADCAST_MODE_ASYNC: BroadcastMode.ValueType  # 3
"""BROADCAST_MODE_ASYNC defines a tx broadcasting mode where the client returns
immediately.
"""
global___BroadcastMode = BroadcastMode

@typing_extensions.final
class GetTxsEventRequest(google.protobuf.message.Message):
    """GetTxsEventRequest is the request type for the Service.TxsByEvents
    RPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EVENTS_FIELD_NUMBER: builtins.int
    PAGINATION_FIELD_NUMBER: builtins.int
    ORDER_BY_FIELD_NUMBER: builtins.int
    PAGE_FIELD_NUMBER: builtins.int
    LIMIT_FIELD_NUMBER: builtins.int
    @property
    def events(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """events is the list of transaction event type."""
    @property
    def pagination(self) -> cosmos.base.query.v1beta1.pagination_pb2.PageRequest:
        """pagination defines a pagination for the request.
        Deprecated post v0.46.x: use page and limit instead.
        """
    order_by: global___OrderBy.ValueType
    page: builtins.int
    """page is the page number to query, starts at 1. If not provided, will default to first page."""
    limit: builtins.int
    """limit is the total number of results to be returned in the result page.
    If left empty it will default to a value to be set by each app.
    """
    def __init__(
        self,
        *,
        events: collections.abc.Iterable[builtins.str] | None = ...,
        pagination: cosmos.base.query.v1beta1.pagination_pb2.PageRequest | None = ...,
        order_by: global___OrderBy.ValueType = ...,
        page: builtins.int = ...,
        limit: builtins.int = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["pagination", b"pagination"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["events", b"events", "limit", b"limit", "order_by", b"order_by", "page", b"page", "pagination", b"pagination"]) -> None: ...

global___GetTxsEventRequest = GetTxsEventRequest

@typing_extensions.final
class GetTxsEventResponse(google.protobuf.message.Message):
    """GetTxsEventResponse is the response type for the Service.TxsByEvents
    RPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TXS_FIELD_NUMBER: builtins.int
    TX_RESPONSES_FIELD_NUMBER: builtins.int
    PAGINATION_FIELD_NUMBER: builtins.int
    TOTAL_FIELD_NUMBER: builtins.int
    @property
    def txs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.tx.v1beta1.tx_pb2.Tx]:
        """txs is the list of queried transactions."""
    @property
    def tx_responses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.base.abci.v1beta1.abci_pb2.TxResponse]:
        """tx_responses is the list of queried TxResponses."""
    @property
    def pagination(self) -> cosmos.base.query.v1beta1.pagination_pb2.PageResponse:
        """pagination defines a pagination for the response.
        Deprecated post v0.46.x: use total instead.
        """
    total: builtins.int
    """total is total number of results available"""
    def __init__(
        self,
        *,
        txs: collections.abc.Iterable[cosmos.tx.v1beta1.tx_pb2.Tx] | None = ...,
        tx_responses: collections.abc.Iterable[cosmos.base.abci.v1beta1.abci_pb2.TxResponse] | None = ...,
        pagination: cosmos.base.query.v1beta1.pagination_pb2.PageResponse | None = ...,
        total: builtins.int = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["pagination", b"pagination"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["pagination", b"pagination", "total", b"total", "tx_responses", b"tx_responses", "txs", b"txs"]) -> None: ...

global___GetTxsEventResponse = GetTxsEventResponse

@typing_extensions.final
class BroadcastTxRequest(google.protobuf.message.Message):
    """BroadcastTxRequest is the request type for the Service.BroadcastTxRequest
    RPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_BYTES_FIELD_NUMBER: builtins.int
    MODE_FIELD_NUMBER: builtins.int
    tx_bytes: builtins.bytes
    """tx_bytes is the raw transaction."""
    mode: global___BroadcastMode.ValueType
    def __init__(
        self,
        *,
        tx_bytes: builtins.bytes = ...,
        mode: global___BroadcastMode.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["mode", b"mode", "tx_bytes", b"tx_bytes"]) -> None: ...

global___BroadcastTxRequest = BroadcastTxRequest

@typing_extensions.final
class BroadcastTxResponse(google.protobuf.message.Message):
    """BroadcastTxResponse is the response type for the
    Service.BroadcastTx method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_RESPONSE_FIELD_NUMBER: builtins.int
    @property
    def tx_response(self) -> cosmos.base.abci.v1beta1.abci_pb2.TxResponse:
        """tx_response is the queried TxResponses."""
    def __init__(
        self,
        *,
        tx_response: cosmos.base.abci.v1beta1.abci_pb2.TxResponse | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["tx_response", b"tx_response"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx_response", b"tx_response"]) -> None: ...

global___BroadcastTxResponse = BroadcastTxResponse

@typing_extensions.final
class SimulateRequest(google.protobuf.message.Message):
    """SimulateRequest is the request type for the Service.Simulate
    RPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_FIELD_NUMBER: builtins.int
    TX_BYTES_FIELD_NUMBER: builtins.int
    @property
    def tx(self) -> cosmos.tx.v1beta1.tx_pb2.Tx:
        """tx is the transaction to simulate.
        Deprecated. Send raw tx bytes instead.
        """
    tx_bytes: builtins.bytes
    """tx_bytes is the raw transaction.

    Since: cosmos-sdk 0.43
    """
    def __init__(
        self,
        *,
        tx: cosmos.tx.v1beta1.tx_pb2.Tx | None = ...,
        tx_bytes: builtins.bytes = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["tx", b"tx"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx", b"tx", "tx_bytes", b"tx_bytes"]) -> None: ...

global___SimulateRequest = SimulateRequest

@typing_extensions.final
class SimulateResponse(google.protobuf.message.Message):
    """SimulateResponse is the response type for the
    Service.SimulateRPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GAS_INFO_FIELD_NUMBER: builtins.int
    RESULT_FIELD_NUMBER: builtins.int
    @property
    def gas_info(self) -> cosmos.base.abci.v1beta1.abci_pb2.GasInfo:
        """gas_info is the information about gas used in the simulation."""
    @property
    def result(self) -> cosmos.base.abci.v1beta1.abci_pb2.Result:
        """result is the result of the simulation."""
    def __init__(
        self,
        *,
        gas_info: cosmos.base.abci.v1beta1.abci_pb2.GasInfo | None = ...,
        result: cosmos.base.abci.v1beta1.abci_pb2.Result | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["gas_info", b"gas_info", "result", b"result"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["gas_info", b"gas_info", "result", b"result"]) -> None: ...

global___SimulateResponse = SimulateResponse

@typing_extensions.final
class GetTxRequest(google.protobuf.message.Message):
    """GetTxRequest is the request type for the Service.GetTx
    RPC method.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HASH_FIELD_NUMBER: builtins.int
    hash: builtins.str
    """hash is the tx hash to query, encoded as a hex string."""
    def __init__(
        self,
        *,
        hash: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["hash", b"hash"]) -> None: ...

global___GetTxRequest = GetTxRequest

@typing_extensions.final
class GetTxResponse(google.protobuf.message.Message):
    """GetTxResponse is the response type for the Service.GetTx method."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_FIELD_NUMBER: builtins.int
    TX_RESPONSE_FIELD_NUMBER: builtins.int
    @property
    def tx(self) -> cosmos.tx.v1beta1.tx_pb2.Tx:
        """tx is the queried transaction."""
    @property
    def tx_response(self) -> cosmos.base.abci.v1beta1.abci_pb2.TxResponse:
        """tx_response is the queried TxResponses."""
    def __init__(
        self,
        *,
        tx: cosmos.tx.v1beta1.tx_pb2.Tx | None = ...,
        tx_response: cosmos.base.abci.v1beta1.abci_pb2.TxResponse | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["tx", b"tx", "tx_response", b"tx_response"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx", b"tx", "tx_response", b"tx_response"]) -> None: ...

global___GetTxResponse = GetTxResponse

@typing_extensions.final
class GetBlockWithTxsRequest(google.protobuf.message.Message):
    """GetBlockWithTxsRequest is the request type for the Service.GetBlockWithTxs
    RPC method.

    Since: cosmos-sdk 0.45.2
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HEIGHT_FIELD_NUMBER: builtins.int
    PAGINATION_FIELD_NUMBER: builtins.int
    height: builtins.int
    """height is the height of the block to query."""
    @property
    def pagination(self) -> cosmos.base.query.v1beta1.pagination_pb2.PageRequest:
        """pagination defines a pagination for the request."""
    def __init__(
        self,
        *,
        height: builtins.int = ...,
        pagination: cosmos.base.query.v1beta1.pagination_pb2.PageRequest | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["pagination", b"pagination"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["height", b"height", "pagination", b"pagination"]) -> None: ...

global___GetBlockWithTxsRequest = GetBlockWithTxsRequest

@typing_extensions.final
class GetBlockWithTxsResponse(google.protobuf.message.Message):
    """GetBlockWithTxsResponse is the response type for the Service.GetBlockWithTxs method.

    Since: cosmos-sdk 0.45.2
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TXS_FIELD_NUMBER: builtins.int
    BLOCK_ID_FIELD_NUMBER: builtins.int
    BLOCK_FIELD_NUMBER: builtins.int
    PAGINATION_FIELD_NUMBER: builtins.int
    @property
    def txs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[cosmos.tx.v1beta1.tx_pb2.Tx]:
        """txs are the transactions in the block."""
    @property
    def block_id(self) -> tendermint.types.types_pb2.BlockID: ...
    @property
    def block(self) -> tendermint.types.block_pb2.Block: ...
    @property
    def pagination(self) -> cosmos.base.query.v1beta1.pagination_pb2.PageResponse:
        """pagination defines a pagination for the response."""
    def __init__(
        self,
        *,
        txs: collections.abc.Iterable[cosmos.tx.v1beta1.tx_pb2.Tx] | None = ...,
        block_id: tendermint.types.types_pb2.BlockID | None = ...,
        block: tendermint.types.block_pb2.Block | None = ...,
        pagination: cosmos.base.query.v1beta1.pagination_pb2.PageResponse | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["block", b"block", "block_id", b"block_id", "pagination", b"pagination"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["block", b"block", "block_id", b"block_id", "pagination", b"pagination", "txs", b"txs"]) -> None: ...

global___GetBlockWithTxsResponse = GetBlockWithTxsResponse

@typing_extensions.final
class TxDecodeRequest(google.protobuf.message.Message):
    """TxDecodeRequest is the request type for the Service.TxDecode
    RPC method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_BYTES_FIELD_NUMBER: builtins.int
    tx_bytes: builtins.bytes
    """tx_bytes is the raw transaction."""
    def __init__(
        self,
        *,
        tx_bytes: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx_bytes", b"tx_bytes"]) -> None: ...

global___TxDecodeRequest = TxDecodeRequest

@typing_extensions.final
class TxDecodeResponse(google.protobuf.message.Message):
    """TxDecodeResponse is the response type for the
    Service.TxDecode method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_FIELD_NUMBER: builtins.int
    @property
    def tx(self) -> cosmos.tx.v1beta1.tx_pb2.Tx:
        """tx is the decoded transaction."""
    def __init__(
        self,
        *,
        tx: cosmos.tx.v1beta1.tx_pb2.Tx | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["tx", b"tx"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx", b"tx"]) -> None: ...

global___TxDecodeResponse = TxDecodeResponse

@typing_extensions.final
class TxEncodeRequest(google.protobuf.message.Message):
    """TxEncodeRequest is the request type for the Service.TxEncode
    RPC method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_FIELD_NUMBER: builtins.int
    @property
    def tx(self) -> cosmos.tx.v1beta1.tx_pb2.Tx:
        """tx is the transaction to encode."""
    def __init__(
        self,
        *,
        tx: cosmos.tx.v1beta1.tx_pb2.Tx | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["tx", b"tx"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx", b"tx"]) -> None: ...

global___TxEncodeRequest = TxEncodeRequest

@typing_extensions.final
class TxEncodeResponse(google.protobuf.message.Message):
    """TxEncodeResponse is the response type for the
    Service.TxEncode method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TX_BYTES_FIELD_NUMBER: builtins.int
    tx_bytes: builtins.bytes
    """tx_bytes is the encoded transaction bytes."""
    def __init__(
        self,
        *,
        tx_bytes: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["tx_bytes", b"tx_bytes"]) -> None: ...

global___TxEncodeResponse = TxEncodeResponse

@typing_extensions.final
class TxEncodeAminoRequest(google.protobuf.message.Message):
    """TxEncodeAminoRequest is the request type for the Service.TxEncodeAmino
    RPC method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AMINO_JSON_FIELD_NUMBER: builtins.int
    amino_json: builtins.str
    def __init__(
        self,
        *,
        amino_json: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["amino_json", b"amino_json"]) -> None: ...

global___TxEncodeAminoRequest = TxEncodeAminoRequest

@typing_extensions.final
class TxEncodeAminoResponse(google.protobuf.message.Message):
    """TxEncodeAminoResponse is the response type for the Service.TxEncodeAmino
    RPC method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AMINO_BINARY_FIELD_NUMBER: builtins.int
    amino_binary: builtins.bytes
    def __init__(
        self,
        *,
        amino_binary: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["amino_binary", b"amino_binary"]) -> None: ...

global___TxEncodeAminoResponse = TxEncodeAminoResponse

@typing_extensions.final
class TxDecodeAminoRequest(google.protobuf.message.Message):
    """TxDecodeAminoRequest is the request type for the Service.TxDecodeAmino
    RPC method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AMINO_BINARY_FIELD_NUMBER: builtins.int
    amino_binary: builtins.bytes
    def __init__(
        self,
        *,
        amino_binary: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["amino_binary", b"amino_binary"]) -> None: ...

global___TxDecodeAminoRequest = TxDecodeAminoRequest

@typing_extensions.final
class TxDecodeAminoResponse(google.protobuf.message.Message):
    """TxDecodeAminoResponse is the response type for the Service.TxDecodeAmino
    RPC method.

    Since: cosmos-sdk 0.47
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AMINO_JSON_FIELD_NUMBER: builtins.int
    amino_json: builtins.str
    def __init__(
        self,
        *,
        amino_json: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["amino_json", b"amino_json"]) -> None: ...

global___TxDecodeAminoResponse = TxDecodeAminoResponse
